/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.editors;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import javax.swing.ImageIcon;
import org.openide.explorer.propertysheet.PropertyEnv;

/**
 *
 * @author Timon Veenstra
 */
public class ImageIconEditor {
  
    private ImageIcon value;

    public void setValue(Object o) {
        this.value = (ImageIcon) o;
    }

    public Object getValue() {
        return value;
    }

    public boolean isPaintable() {
        return true;
    }

    public void paintValue(Graphics grphcs, Rectangle rctngl) {
        if (value != null) {
            int width = 0;
            int height = 0;
            
            double imageRatio = (double)value.getIconWidth()/(double)value.getIconHeight();
            double rctnglRatio = (double)rctngl.width/(double)rctngl.height;
            if (imageRatio<rctnglRatio){
                double factor = (double)rctngl.width/(double)value.getIconWidth();
                width=(int) ((double)value.getIconWidth()*factor);
                height=(int) ((double)value.getIconHeight()*factor);
            }else{
                double factor = (double)rctngl.height/(double)value.getIconHeight();
                width=(int) ((double)value.getIconWidth()*factor);
                height=(int) ((double)value.getIconHeight()*factor);                
            }
            
            grphcs.drawImage(value.getImage(), rctngl.x, rctngl.y, width, height, null);
        }
    }

    public String getJavaInitializationString() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public String getAsText() {
        return value == null ? "empty" : value.toString();
    }

    public void setAsText(String string) throws IllegalArgumentException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public String[] getTags() {
        return null;
    }

    public Component getCustomEditor() {
        return null;
    }

    public boolean supportsCustomEditor() {
        return false;
    }
    private final PropertyChangeSupport supp = new PropertyChangeSupport(this);

    public void addPropertyChangeListener(PropertyChangeListener pl) {
        supp.addPropertyChangeListener(pl);
    }

    public void removePropertyChangeListener(PropertyChangeListener pl) {
        supp.removePropertyChangeListener(pl);
    }
    private PropertyEnv env;

    public void attachEnv(PropertyEnv pe) {
        env = pe;
    }  
}
